Package org.jboss.resteasy.links

## Class RESTServiceDiscovery

- java.lang.Object
- - java.util.AbstractCollection<E>
  - - java.util.AbstractList<E>
    - - java.util.ArrayList<RESTServiceDiscovery.AtomLink>
      - - org.jboss.resteasy.links.RESTServiceDiscovery

- All Implemented Interfaces:
    `Serializable`, `Cloneable`, `Iterable<RESTServiceDiscovery.AtomLink>`, `Collection<RESTServiceDiscovery.AtomLink>`, `List<RESTServiceDiscovery.AtomLink>`, `RandomAccess`

      public class RESTServiceDiscovery
      extends ArrayList<RESTServiceDiscovery.AtomLink>

  This holds a list of atom links describing the REST service discovered. This will be injected by RESTEasy on any entity in the response if the JAX-RS method was annotated with `@AddLinks` if your entity declares a field of this type.

  For this to work you need to add `@LinkResource` annotations on all the JAX-RS methods you want to be discovered.

  Author:
    Stéphane Épardaud
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `RESTServiceDiscovery.AtomLink` | An Atom link

  - ### Field Summary

    - ### Fields inherited from class java.util.AbstractList

      `modCount`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `RESTServiceDiscovery()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addAllLinks​(RESTServiceDiscovery restServiceDiscovery)` |
    `void` | `addLink​(URI uri, String rel)` |
    `RESTServiceDiscovery.AtomLink` | `getLinkForRel​(String rel)` |

    - ### Methods inherited from class java.util.ArrayList

      `add, add, addAll, addAll, clear, clone, contains, ensureCapacity, forEach, get, indexOf, isEmpty, iterator, lastIndexOf, listIterator, listIterator, remove, remove, removeAll, removeIf, removeRange, replaceAll, retainAll, set, size, sort, spliterator, subList, toArray, toArray, trimToSize`

    - ### Methods inherited from class java.util.AbstractList

      `equals, hashCode`

    - ### Methods inherited from class java.util.AbstractCollection

      `containsAll, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, stream`

    - ### Methods inherited from interface java.util.List

      `containsAll, equals, hashCode`

- - ### Constructor Detail

    - #### RESTServiceDiscovery

          public RESTServiceDiscovery()

  - ### Method Detail

    - #### addAllLinks

          public void addAllLinks​(RESTServiceDiscovery restServiceDiscovery)

    - #### addLink

          public void addLink​(URI uri,
                              String rel)

    - #### getLinkForRel

          public RESTServiceDiscovery.AtomLink getLinkForRel​(String rel)